<?php
class Route {
	public function __construct($models_dir, $controllers_dir, $views_dir) {
		Core::run()->models_dir = $models_dir;
		Core::run()->controllers_dir = $controllers_dir;
		Core::run()->views_dir = $views_dir;
	}
	
	public function start() {
		$route = isset($_GET['route']) ? $_GET['route'] : null;
		$route = strtolower($route);
		
		if (empty($route) or $route == null) {
			$model = 'Index';
			$controller = 'IndexController';
			$action = 'actionIndex';
			$views = 'index';
			
			require(ROOT.'/'.Core::run()->models_dir.'/Index.php');
			require(ROOT.'/'.Core::run()->controllers_dir.'/IndexController.php');
		} else {
			$actions = explode('/', $route);
			
			$model = ucfirst($actions[0]);
			$controller = ucfirst($actions[0]).'Controller';
			$action = 'action'.ucfirst($actions[1]);
			$views = $actions[0];
			
			$model_require = ROOT.'/'.Core::run()->models_dir.'/'.$model.'.php';
			$controller_require = ROOT.'/'.Core::run()->controllers_dir.'/'.$controller.'.php';
			
			if (is_file($model_require) and is_file($controller_require)) {
				require($model_require);
				require($controller_require);
			} else {
				$model = 'Index';
				$controller = 'IndexController';
				$action = 'actionIndex';
				$views = 'index';
				
				require(ROOT.'/'.Core::run()->models_dir.'/Index.php');
				require(ROOT.'/'.Core::run()->controllers_dir.'/IndexController.php');
			}
		}
		
		$model = new $model();
		$controller = new $controller($model, $views);
		$controller->$action();
	}
}
?>